/*
 * generated by Xtext 2.11.0
 */
package org.xtext.example.mydsl.tests

import com.google.inject.Inject
import org.eclipse.xtext.testing.InjectWith
import org.eclipse.xtext.testing.XtextRunner
import org.eclipse.xtext.testing.util.ParseHelper
import org.junit.Assert
import org.junit.Test
import org.junit.runner.RunWith
import org.xtext.example.mydsl.myDsl.Model

@RunWith(XtextRunner)
@InjectWith(MyDslInjectorProvider)
class MyDslParsingTest {
	@Inject
	ParseHelper<Model> parseHelper
	
	@Test
	def void loadModel() {
		val result = parseHelper.parse('''
			Hello Xtext!
		''')
		Assert.assertNotNull(result)
		Assert.assertTrue(result.eResource.errors.isEmpty)
	}
}


@RunWith(XtextRunner)
@InjectWith(MyDslInjectorProvider)
class MyDslIndexTest {
	@Inject
	ParseHelper<Model> parseHelper
	@Inject extension MyDslIndex
	
	@Test
	def void loadModel() {
		val result = parseHelper.parse('''
			use kkkk
			use mmmm

			user AAA
			user BBB
			
			Hello AAA!
			Hello CCC!
		''')
		Assert.assertNotNull(result)
		Assert.assertTrue(result.eResource.errors.isEmpty)
		
		val tmp = result.getExportedEObjectDescriptions.map[qualifiedName].join(", ")
		Assert.assertEquals("AAA, BBB", tmp)
		
		val tmp1 = result.exportedEObjectDescriptionsByUse.join(", ")
		Assert.assertEquals("ccc", tmp1)
	}
}
