package org.xtext.example.mydsl.scoping;

import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.scoping.impl.ImportUriResolver;
import org.osgi.framework.Bundle;
import org.xtext.example.mydsl.myDsl.Use;

public class MyDslImportUriResolver extends ImportUriResolver {
	protected static final String BUNDLE_NAME = "org.xtext.example.mydsl";
	protected static final String PLATFORM_PATH = "platform:/plugin/" + BUNDLE_NAME + "/headers/";
	protected static final String FILE_EXT = ".mydsl";

	MyDslImportUriResolver() {
		Bundle bundle = Platform.getBundle(BUNDLE_NAME);
		URL url = bundle.getEntry("headers");
		URI uri = null;
		try {
			uri = FileLocator.toFileURL(url).toURI();
		} catch (URISyntaxException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		File mydirectory = new File(uri);
		File[] listOfFiles = mydirectory.listFiles();

		for (File file : listOfFiles) {
			if (file.isFile()) {
				System.out.println(file.getName());
			}
		}
	}

	@Override
	public String resolve(EObject object) {
		if (object instanceof Use) {
			return PLATFORM_PATH + ((Use) object).getImportURI() + FILE_EXT;
		}

		return super.resolve(object);
	}
}
